--------------------------------------------------------------------------------
-- Copyright (C) 2004 Trenz Electronic GmbH
-- www.trenz-electronic.de
-- Author:      Kolja Sulimma
--------------------------------------------------------------------------------
-- Project:     TE-XC3S Application Note: Pong Demo
-- File:        sound.vhd
-- Description: Sound output for the Pong Demo
-- History:     V1.0 2004-10-13 KS created
--------------------------------------------------------------------------------
-- This program is free software; you can redistribute it and/or
-- modify it under the terms of the GNU General Public License
-- as published by the Free Software Foundation; either version 2
-- of the License, or (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity sound is
    Port ( clk : in std_logic;
    		sound_clk : in std_logic;
    		 start_beep : in std_logic;
           framestrobe : in std_logic;
           dir_x : in std_logic;
           aud_out : out std_logic_vector(1 to 4)
		 );
end sound;

architecture Behavioral of sound is begin 

process 
variable counter : integer range 0 to 7;
begin
	wait until rising_edge(clk);
	if start_beep = '1' then -- sound a beep for 7 frames 
		counter := 7;
   elsif counter /= 0 and framestrobe = '1' then 
	   counter := counter - 1;
	end if;

	if counter /= 0 then	 
	   if dir_x = '0' then
		  aud_out(1) <= sound_clk;
		  aud_out(2) <= '0';
		else
		  aud_out(1) <= '0';
		  aud_out(2) <= sound_clk;
		end if;
	else
		  aud_out(1) <= '0';
		  aud_out(2) <= '0';
	end if;
end process;

end Behavioral;
