
-- VHDL Test Bench Created from source file toplevel.vhd -- 00:04:49 08/21/2004
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

ENTITY toplevel_testbench_vhd_tb IS
END toplevel_testbench_vhd_tb;

ARCHITECTURE behavior OF toplevel_testbench_vhd_tb IS 

	COMPONENT toplevel
	PORT(
		utmi_clkout : IN std_logic;
		ps2_clk1 : IN std_logic;
		ps2_data1 : IN std_logic;
		ps2_clk2 : IN std_logic;
		ps2_data2 : IN std_logic;
		joy_up : IN std_logic;
		joy_down : IN std_logic;
		joy_right : IN std_logic;
		joy_left : IN std_logic;
		joy_fire : IN std_logic;
		reset : IN std_logic;
		fpga_rxd : IN std_logic;
		fpga_cts : IN std_logic;    
		vsync_b : INOUT std_logic;
		hsync_b : INOUT std_logic;
		ram_io : INOUT std_logic_vector(15 downto 0);      
		utmi_databus16_8 : OUT bit;
		utmi_reset : OUT bit;
		utmi_xcvrselect : OUT bit;
		utmi_termselect : OUT bit;
		utmi_opmode1 : OUT bit;
		utmi_txvalid : OUT bit;
		fpga_r : OUT std_logic_vector(2 downto 0);
		fpga_g : OUT std_logic_vector(2 downto 0);
		fpga_b : OUT std_logic_vector(2 downto 0);
		led : OUT std_logic_vector(1 to 4);
		mm_led : OUT std_logic;
		aud_out : OUT std_logic_vector(1 to 4);
		lcd_d : OUT std_logic_vector(7 downto 4);
		lcd_e : OUT std_logic;
		lcd_rw : OUT std_logic;
		lcd_rs : OUT std_logic;
		ram_a : OUT std_logic_vector(18 downto 1);
		ram_ce : OUT std_logic;
		ram_oe : OUT std_logic;
		ram_we : OUT std_logic;
		ram_bhe : OUT std_logic;
		ram_ble : OUT std_logic;
		fpga_txd : OUT std_logic;
		fpga_rts : OUT std_logic
		);
	END COMPONENT;

	SIGNAL utmi_databus16_8 :  bit;
	SIGNAL utmi_reset :  bit;
	SIGNAL utmi_xcvrselect :  bit;
	SIGNAL utmi_termselect :  bit;
	SIGNAL utmi_opmode1 :  bit;
	SIGNAL utmi_txvalid :  bit;
	SIGNAL utmi_clkout :  std_logic := '0';
	SIGNAL fpga_r :  std_logic_vector(2 downto 0);
	SIGNAL fpga_g :  std_logic_vector(2 downto 0);
	SIGNAL fpga_b :  std_logic_vector(2 downto 0);
	SIGNAL vsync_b :  std_logic;
	SIGNAL hsync_b :  std_logic;
	SIGNAL ps2_clk1 :  std_logic;
	SIGNAL ps2_data1 :  std_logic;
	SIGNAL ps2_clk2 :  std_logic;
	SIGNAL ps2_data2 :  std_logic;
	SIGNAL led :  std_logic_vector(1 to 4);
	SIGNAL joy_up :  std_logic;
	SIGNAL joy_down :  std_logic;
	SIGNAL joy_right :  std_logic;
	SIGNAL joy_left :  std_logic;
	SIGNAL joy_fire :  std_logic;
	SIGNAL reset :  std_logic := '0';
	SIGNAL mm_led :  std_logic;
	SIGNAL aud_out :  std_logic_vector(1 to 4);
	SIGNAL lcd_d :  std_logic_vector(7 downto 4);
	SIGNAL lcd_e :  std_logic;
	SIGNAL lcd_rw :  std_logic;
	SIGNAL lcd_rs :  std_logic;
	SIGNAL ram_a :  std_logic_vector(18 downto 1);
	SIGNAL ram_io :  std_logic_vector(15 downto 0);
	SIGNAL ram_ce :  std_logic;
	SIGNAL ram_oe :  std_logic;
	SIGNAL ram_we :  std_logic;
	SIGNAL ram_bhe :  std_logic;
	SIGNAL ram_ble :  std_logic;
	SIGNAL fpga_txd :  std_logic;
	SIGNAL fpga_rts :  std_logic;
	SIGNAL fpga_rxd :  std_logic;
	SIGNAL fpga_cts :  std_logic;

BEGIN

	uut: toplevel PORT MAP(
		utmi_databus16_8 => utmi_databus16_8,
		utmi_reset => utmi_reset,
		utmi_xcvrselect => utmi_xcvrselect,
		utmi_termselect => utmi_termselect,
		utmi_opmode1 => utmi_opmode1,
		utmi_txvalid => utmi_txvalid,
		utmi_clkout => utmi_clkout,
		fpga_r => fpga_r,
		fpga_g => fpga_g,
		fpga_b => fpga_b,
		vsync_b => vsync_b,
		hsync_b => hsync_b,
		ps2_clk1 => ps2_clk1,
		ps2_data1 => ps2_data1,
		ps2_clk2 => ps2_clk2,
		ps2_data2 => ps2_data2,
		led => led,
		joy_up => joy_up,
		joy_down => joy_down,
		joy_right => joy_right,
		joy_left => joy_left,
		joy_fire => joy_fire,
		reset => reset,
		mm_led => mm_led,
		aud_out => aud_out,
		lcd_d => lcd_d,
		lcd_e => lcd_e,
		lcd_rw => lcd_rw,
		lcd_rs => lcd_rs,
		ram_a => ram_a,
		ram_io => ram_io,
		ram_ce => ram_ce,
		ram_oe => ram_oe,
		ram_we => ram_we,
		ram_bhe => ram_bhe,
		ram_ble => ram_ble,
		fpga_txd => fpga_txd,
		fpga_rts => fpga_rts,
		fpga_rxd => fpga_rxd,
		fpga_cts => fpga_cts
	);


-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
      wait for 5 ns; -- will wait forever
		utmi_clkout <= not utmi_clkout; 
   END PROCESS;

	tb2 : PROCESS
   BEGIN
      wait for 15 ns; -- will wait forever
		reset <= '1';
		wait; 
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
